#include <stdio.h>
#include <mem.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define TRUE            1
#define FALSE           0

#define DONE            1
#define NOT_DONE        0

#define MAX_ROWS	    13
#define MAX_COLS	    32

#define BUF_SIZE        MAX_ROWS * MAX_COLS + 3

#define BLOCK           1
#define BLOCK_SAFE      2
#define WALL_BLOCK      3
#define PUSHER          4
#define PUSHER_SAFE     5
#define SAFE_SPOT       6
#define BLANK_SPOT      7

main()
{
	int buf_size, i, i1, i2, i3, r, c;

	char num_levels = 0;

	unsigned char sokdisk[208];

	char buffer[BUF_SIZE];

	char MazeArray[MAX_COLS][MAX_ROWS];

	char temp1, temp2;

	FILE *infile, *outfile;

	if((infile = fopen("NEW-LEV.TXT", "r")) == NULL){
		puts("Cannot open the input file");
		exit(1);
	}

	if((outfile = fopen("NEW-LEV.SOK", "wb")) == NULL){
		puts("Cannot open the output file");
		exit(1);
	}

	while(fgets(buffer, BUF_SIZE, infile) != NULL){

		if (buffer[0] == '\n')
			continue;

		for (i2 = 1; i2 < MAX_ROWS; i2++){
			fgets(buffer + (i2 * MAX_COLS), BUF_SIZE, infile);
		}

		for(i = 0; i < 416; i++){

			r = i / 32;
			c = i - (r * 32);

			switch(buffer[i]){
				case '.':
					MazeArray[c][r] = WALL_BLOCK;
					break;
				case '1':
					MazeArray[c][r] = BLOCK;
					break;
				case '2':
					MazeArray[c][r] = BLOCK_SAFE;
					break;
				case '3':
					MazeArray[c][r] = PUSHER;
					break;
				case '4':
					MazeArray[c][r] = PUSHER_SAFE;
					break;
				case '5':
					MazeArray[c][r] = SAFE_SPOT;
					break;
				case ' ':
					MazeArray[c][r] = BLANK_SPOT;
					break;
			}
		}
			num_levels++;

			i2 = 0;

			for(i1 = 0; i1 < (MAX_ROWS * MAX_COLS); i1++){
				r = i1 / 32;
				c = i1 - (r * 32);

				if(!(i1 & 1)){
					temp1 = MazeArray[c][r];
					temp1 <<= 4;
				}
				else if(i1 & 1){
					temp2 = MazeArray[c][r];
					sokdisk[i2] = temp1 | temp2;
					i2++;
				}
			}

			fseek(outfile, num_levels * sizeof(sokdisk), SEEK_SET);

			fwrite(sokdisk, sizeof(sokdisk), 1, outfile);

	}

	memset(sokdisk, 0, 208 * sizeof(char));

	sokdisk[0] = num_levels;

	fseek(outfile, 0L, SEEK_SET);
	fwrite(sokdisk, sizeof(sokdisk), 1, outfile);

	fclose(infile);
	fclose(outfile);

	return(0);

}